import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        String[][] a = new String[n][6];
        for (int i = 0; i < n; i++) {
            a[i]=nextToken().split("");
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 6; j++) {
                if(a[i][j].equals("X") && a[i][5-j].equals(".")){
                     m--;
                     a[i][5-j]="X";
                     if(m<0){
                         out.println("Impossible");
                         out.close();
                         System.exit(0);
                     }
                }
            }
        }
        if(m!=0){
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < 6; j++) {
                    if(a[i][j].equals(".") && a[i][5-j].equals(".")){
                        a[i][j]="X";
                        a[i][5-j]="X";
                        m-=2;
                        if(m<0){
                            out.println("Impossible");
                            out.close();
                            System.exit(0);
                        }
                    }
                }
            }
            if(m>0){
                out.println("Impossible");
                out.close();
                System.exit(0);
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 6; j++) {
               out.print(a[i][j]);
            }
            out.println();
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}