import java.io.*;
import java.util.*;

public class Task6 {
    public static int binpoisk(int[] a, int[] t, int n, int m1, int max){
        int l = -1;
        int r = max+1;
        while(r-l>1){
            int m = (r+l)/2;
            long cnt = 0;
            for (int i = 0; i < n; i++) {
                if (a[i] <= m) {
                    cnt++;
                    if (m - a[i] - t[i]<= 33) {
                        for (int j = 0; j <= m - a[i] - t[i]; j++) {
                            cnt += (long) Math.pow(2, j);
                            if (cnt > m1){
                                break;
                            }
                        }
                    }
                    else {
                        r = m;
                        break;
                    }
                }
            }
            if(r!=m) {
                if (cnt > m1 ) {
                    r = m;
                } else if (cnt == m1) {
                    return m;
                } else {
                    l = m;
                }
            }
        }
        return -1;
    }
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i]=nextInt();
        }
        int[] t = new int[n];
        for (int i = 0; i < n; i++) {
            t[i] = nextInt();
        }
        int max = 0;
        for (int i = 0; i < n; i++) {
            max = Math.max(max,a[i]+t[i]+33);
        }
        out.println(binpoisk(a,t,n,m,max));
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}