import java.io.*;
import java.util.*;

public class Task6 {
    public static class bacterias{
        int a;
        int t;
        public bacterias(int a, int t) {
            this.a = a;
            this.t = t;
        }
    }
    public static class TheComparator implements Comparator<bacterias>{
        public int compare(bacterias o1, bacterias o2){
            return Integer.compare(o1.a,o2.a);
        }
    }
    public static int binpoisk(bacterias[] a, int n, int m1, int max){
        int l = -1;
        int r = max+1;
        while(r-l>1){
            int m = (r+l)/2;
            long cnt = 0;
            for (int i = 0; i < n; i++) {
                if (a[i].a <= m) {
                    cnt++;
                    if (m - a[i].a - a[i].t<= 32 && m - a[i].a - a[i].t>=0) {
                        cnt += (long) Math.pow(2, m - a[i].a - a[i].t+1)-1;
                    }
                    else if(m - a[i].a - a[i].t > 32){
                        r = m;
                        break;
                    }
                }
                else{
                    break;
                }
            }
            if(r!=m) {
                if (cnt > m1 || cnt<0) {
                    r = m;
                } else if (cnt == m1) {
                    return m;
                } else {
                    l = m;
                }
            }
        }
        return -1;
    }
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        bacterias[] a = new bacterias[n];
        for (int i = 0; i < n; i++) {
            a[i]=new bacterias(nextInt(), 0);
        }
        for (int i = 0; i < n; i++) {
            a[i].t=nextInt();
        }
        Arrays.sort(a, new TheComparator());
        int max = 0;
        for (int i = 0; i < n; i++) {
            max = Math.max(max,a[i].a+a[i].t+33);
        }
        out.println(binpoisk(a,n,m,max));
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}